# xv6-sifive

xv6移植到qemu的sifive_u以及fu740的板子上
本代码基于xv6-k210改编而来

# 文档索引
[内核实现-内存管理](./doc/%E5%86%85%E6%A0%B8%E5%AE%9E%E7%8E%B0--%E5%86%85%E5%AD%98%E7%AE%A1%E7%90%86.md)  
[内核实现-多核启动](./doc/%E5%86%85%E6%A0%B8%E5%AE%9E%E7%8E%B0--%E5%A4%9A%E6%A0%B8%E5%90%AF%E5%8A%A8.md)  
[内核实现-文件系统](./doc/%E5%86%85%E6%A0%B8%E5%AE%9E%E7%8E%B0--%E6%96%87%E4%BB%B6%E7%B3%BB%E7%BB%9F.md)  
[内核实现-时钟中断](./doc/%E5%86%85%E6%A0%B8%E5%AE%9E%E7%8E%B0--%E6%97%B6%E9%92%9F%E4%B8%AD%E6%96%AD.md)  
[内核实现-系统调用](./doc/%E5%86%85%E6%A0%B8%E5%AE%9E%E7%8E%B0--%E7%B3%BB%E7%BB%9F%E8%B0%83%E7%94%A8.md)  
[内核实现-输入输出](./doc/%E5%86%85%E6%A0%B8%E5%AE%9E%E7%8E%B0--%E8%BE%93%E5%85%A5%E8%BE%93%E5%87%BA.md)  
[内核设计-内存映射](./doc/%E5%86%85%E6%A0%B8%E8%AE%BE%E8%AE%A1-%E5%86%85%E5%AD%98%E6%98%A0%E5%B0%84.md)  
[系统调用-内存管理](./doc/%E7%B3%BB%E7%BB%9F%E8%B0%83%E7%94%A8--%E5%86%85%E5%AD%98%E7%AE%A1%E7%90%86%E7%9B%B8%E5%85%B3.md)  
[系统调用-进程管理](./doc/%E7%B3%BB%E7%BB%9F%E8%B0%83%E7%94%A8--%E8%BF%9B%E7%A8%8B%E7%AE%A1%E7%90%86%E7%9B%B8%E5%85%B3.md)  
[系统调用-其他](./doc/%E7%B3%BB%E7%BB%9F%E8%B0%83%E7%94%A8--%E5%85%B6%E4%BB%96.md)  

## 使用方法

```
git clone https://github.com/HUST-OS/xv6-sifive_u.git
cd xv6-sifive_u
```

然后您可以在qemu上进行运行:

```
make qemu
```

如果要生成二进制文件，执行一下命令生成os.bin

```
make all
```


## 调试选项

### 平台选项

在qemu上调试
```
make all platform=qemu
```
在fu740上调试
```
make all platform=sifive_u
```
默认为qemu平台

### 用户态选项

命令行形式（使用user文件夹中的可执行文件）
```
make all init=cmd-user
```
命令行形式（使用sd文件夹中的可执行文件）
```
make all init=cmd-sd
```
执行sd下所有的测试文件
```
make all init=runall
```
helloworld测试用户态
```
make qemu init=hello
```
默认为cmd-user

### 文件系统选项

基于SD卡
```
make all fat=SD
```
基于内存
```
make all fat=RAM
```

## 我们的工作

- 调试操作系统启动的引导程序,使得操作系统多核启动能够顺利执行.
- 调试SBI输入输出函数,使得操作系统能够正常进行键盘输入.
- 调试底层文件系统接口,使用RAM来模拟磁盘.
- 利用spi协议读写sd卡为文件系统提供支持.
- 调试FAT32文件系统,为用户程序提供稳定的文件操作接口.
- 写好相关文档，相关文档放在了doc文件夹中


## 可用分支

`sacrifice`分支:操作系统stable版本
