*Author: Sukuna&OS Competition*

### #define SYS_times 153

* 功能：获取进程时间；
* 输入：tms结构体指针，用于获取保存当前进程的运行时间数据；
* 返回值：成功返回已经过去的滴答数，失败返回-1;

```
struct tms *tms;
clock_t ret = syscall(SYS_times, tms);
```

对于这个syscall我们添加了一个`proc_tick()`的函数,这个函数在每一次时钟中断的时候都会维护每个进程的tms结构体.具体维护的方法可以参见时钟中断的相关处理.

具体的函数参见`sys_times()`,函数的实现很简单,根据当前进程的结构体提取出来返回到用户态即可.

### #define SYS_uname 160

* 功能：打印系统信息；
* 输入：utsname结构体指针用于获得系统信息数据；
* 返回值：成功返回0，失败返回-1;

```
struct utsname *uts;
int ret = syscall(SYS_uname, uts);
```

具体的函数参见`sys_uname()`,函数的实现很简单,直接调用内核的uname_copyout()即可.这个函数会把相关的信息传到用户态的addr的地址中.

### #define SYS_sched_yield 124

* 功能：让出调度器；
* 输入：系统调用ID；
* 返回值：成功返回0，失败返回-1;

```
int ret = syscall(SYS_sched_yield);
```

具体的函数参见`sys_yield()`,函数的实现很简单,直接调用内核的yiled()函数即可.

### #define SYS_gettimeofday 169

* 功能：获取时间；
* 输入： timespec结构体指针用于获得时间值；
* 返回值：成功返回0，失败返回-1;

```
struct timespec *ts;
int ret = syscall(SYS_gettimeofday, ts, 0);
```

具体的函数参见`sys_gettimeofday`,首先调用r_time()函数,获取现在的时间寄存器的数据,然后根据转化函数获取转化成秒和毫秒.转化的方式在函数中有表达.

### #define SYS_nanosleep 101

* 功能：执行线程睡眠，sleep()库函数基于此系统调用；
* 输入：睡眠的时间间隔；

```
struct timespec {
	time_t tv_sec;        /* 秒 */
	long   tv_nsec;       /* 纳秒, 范围在0~999999999 */
};
```

* 返回值：成功返回0，失败返回-1;

```
const struct timespec *req, struct timespec *rem;
int ret = syscall(SYS_nanosleep, req, rem);
```

具体的函数参见`sys_sleep()`,在进程结构体中我们有一个chan表示进程因何而睡眠,我们在这里记录下来.记录的方式是`sleep(&ticks, &p->lock); `
