#include "include/types.h"
#include "include/param.h"
#include "include/memlayout.h"
#include "include/riscv.h"
#include "include/spinlock.h"
#include "include/proc.h"
#include "include/vm.h"
#include "include/debug.h"
#include "include/trap.h"
#include "include/syscall.h"
#include "include/printf.h"



int
debugf52f78(struct proc* p,uint64 va)
{
  p->trapframe->a0 += 1996;
  printf("dso app addr:%p\n",p->trapframe->a0);
  pagetable_t pagetable = p->pagetable;
  char* pa = (void*)kwalkaddr1(pagetable,p->trapframe->a0);
  
  printf("dso app dynv addr:%p\n",*(uint64*)(pa+16));
  p->trapframe->epc += 4;
  return 0;
}


int
debugf50d8e(struct proc* p,uint64 va)
{
  //pagetable_t pagetable = p->pagetable;
  printf("enter kernel mapped dso:%p\n",p->trapframe->a0);
  printf("dso phdr:%p\n",p->trapframe->a5);
  printf("dso phnum:%p\n",p->trapframe->t6);
  printf("dso base:%p\n",p->trapframe->a7);
  p->trapframe->sp -= 48;
  p->trapframe->epc += 2;
  return 0;
}

int
debugf524b2(struct proc* p,uint64 va)
{
  pagetable_t pagetable = p->pagetable;
  uint64 va2 = p->trapframe->a0;
  uint64* pa = (void*)kwalkaddr1(pagetable,va2+176);
  uint64* pa2 = (void*)kwalkaddr1(pagetable,va2+24);
  p->trapframe->a5 = *pa;
  printf("dso:%p deps:%p\n",p->trapframe->a0,*pa);
  printf("next:%p\n",*pa2);
  p->trapframe->epc += 2;
  return 0;
}



int
debugf51d7e(struct proc* p,uint64 va)
{
  pagetable_t pagetable = p->pagetable;
  uint64 va2 = p->trapframe->a0;
  uint64* pa = (void*)kwalkaddr1(pagetable,va2);
  printf("library:%s\n",pa);
  p->trapframe->sp -= 1184;
  p->trapframe->epc += 4;
  return 0;
}

int
debugf50e08(struct proc* p,uint64 va)
{
  //pagetable_t pagetable = p->pagetable;
  printf("kernel mapped dso:%p\n",p->trapframe->a0);
  printf("kernel mapped dso base:%p\n",p->trapframe->a7);
  printf("kernel mapped dso dynamic phdr:%p\n",p->trapframe->a5);
  printf("kernel mapped dso dynamic phdr vaddr:%p\n",p->trapframe->a1);
  p->trapframe->a1 += p->trapframe->a7;
  p->trapframe->epc += 2;
  return 0;
}


int
debugaddr(struct proc* p,uint64 va)
{
/*
  if(va == 0xf52f78){
    return debugf52f78(p,va);
  }else if(va == 0xf50e08){
    return debugf50e08(p,va);
  }else if(va == 0xf50d8e){
    return debugf50d8e(p,va);
  }else if(va == 0xf524b2){
    return debugf524b2(p,va);
  }else if(va == 0xf51d7e){
    return debugf51d7e(p,va);
  }
*/
  return -1;
}
