#ifndef __FILE_H
#define __FILE_H

#include "types.h"

struct file {
  enum { FD_NONE, FD_PIPE, FD_ENTRY, FD_DEVICE } type;
  int ref; // reference count
  char readable;
  char writable;
  struct pipe *pipe; // FD_PIPE
  struct dirent *ep;
  uint off;          // FD_ENTRY
  short major;       // FD_DEVICE
};

// #define major(dev)  ((dev) >> 16 & 0xFFFF)
// #define minor(dev)  ((dev) & 0xFFFF)
// #define	mkdev(m,n)  ((uint)((m)<<16| (n)))

// map major device number to device functions.
struct devsw {
  int (*read)(int, uint64, int);
  int (*write)(int, uint64, int);
};

extern struct devsw devsw[];
#define SOCKET 1919810
#define CONSOLE 1
#define AT_FDCWD (-100)

#define SEEK_SET  (int)0
#define SEEK_CUR  (int)1
#define SEEK_END  (int)2

struct file*    filealloc(void);
void            fileclose(struct file*);
struct file*    filedup(struct file*);
void            fileinit(void);
int             fileread(struct file*, uint64, int);
int             filestat(struct file*, uint64 addr);
int		          filekstat(struct file *f, uint64 addr);
int             filewrite(struct file*, uint64, int n);
int             dirnext(struct file *f, uint64 addr);
int             dirent_next(struct file *f, uint64 addr, int n);
uint64			filelseek(struct file *f, uint64 offset, int whence);
#endif
