#include "include/types.h"
#include "include/riscv.h"
#include "include/param.h"
#include "include/memlayout.h"
#include "include/spinlock.h"
#include "include/proc.h"
#include "include/syscall.h"
#include "include/timer.h"
#include "include/kalloc.h"
#include "include/string.h"
#include "include/printf.h"
#include "include/sbi2.h"
#include "include/console.h"
#include "include/string.h"
#include "include/vm.h"
#include "include/uname.h"
#include "include/socket.h"
// #define SOCKET_DEBUG
extern struct socket_connection sockets[10];
uint64 sys_socket(void){
    int IP;
    int opt;
    argint(0, &IP);
    argint(1, &opt);
    int a = add_socket(IP,opt);
    #ifdef SOCKET_DEBUG
    printf("sokcet:fd:%d\n",SOCKET+a);
    #endif
    return SOCKET+a;
}

uint64 sys_socketpair(void){
    int IP;
    uint64 addr;
    argint(0, &IP);
    argaddr(1, &addr);
    // not used...
    return 0;
}
uint64 sys_bind(void){
    int fd;
    uint64 socket_addr; 
    argint(0, &fd);
    #ifdef SOCKET_DEBUG
    printf("bind:fd:%d\n",fd);
    #endif
    argaddr(1, &socket_addr);
    if(fd >= SOCKET){
        sockets[fd - SOCKET].sock_addr = socket_addr;
        return 0;
    }
    else return -1;
}
uint64 sys_listen(void){
    int fd;
    argint(0, &fd);
    if(fd >= SOCKET){
        sockets[fd - SOCKET].passive_socket = 1;
        return 0;
    }
    else return -1;
}
uint64 sys_accept(void){
    int fd;
    uint64 addr;
    argint(0, &fd);
    argaddr(1, &addr);
    if(fd >= SOCKET){
        if(sockets[fd - SOCKET].passive_socket == 1) return 1;
        else return 0;
    }
    else return -1;
}
uint64 sys_connect(void){
    int fd;
    uint64 addr;
    argint(0, &fd);
    argaddr(1, &addr);
    // need to analayze the file in addr.
    if(fd >= SOCKET){
        // unfinished...
        return 0;
    }
    else return -1;
}
uint64 sys_getsockname(void){
    int fd;
    uint64 addr;
    argint(0, &fd);
    argaddr(1, &addr);
    // need to analayze the file in addr.
    if(fd >= SOCKET){
        // unfinished...
        return 0;
    }
    else return -1;
}
uint64 sys_getpeername(void){
    int fd;
    uint64 addr;
    argint(0, &fd);
    argaddr(1, &addr);
    // need to analayze the file in addr.
    if(fd >= SOCKET){
        // unfinished...
        return 0;
    }
    else return -1;
}
uint64 sys_sendto(void){
    int fd;
    uint64 addr;
    int len;
    argint(0, &fd);
    argint(2, &len);
    argaddr(1, &addr);
    #ifdef SOCKET_DEBUG
    printf("sendto:fd:%d\n",fd);
    #endif
    if(fd >= SOCKET){
        copyin2(sockets[fd - SOCKET - 1].temp, addr, len);
        #ifdef SOCKET_DEBUG
        printf("sokcet_send:%s\n",sockets[fd - SOCKET - 1].temp);
        #endif
        return len;
    }
    else return 0;
}
uint64 sys_recvfrom(void){
    int fd;
    uint64 addr;
    int len;
    argint(0, &fd);
    argint(2, &len);
    argaddr(1, &addr);
    #ifdef SOCKET_DEBUG
    printf("recvfrom:fd:%d\n",fd);
    #endif
    if(fd >= SOCKET){
        int i = 0;
        for(i = 0;sockets[fd - SOCKET].temp[i]; i++){
            copyout2(addr + i,sockets[fd - SOCKET].temp + i ,1);
        }
        return i;
    }
    else return 0;
}
uint64 sys_setsockopt(void){
    int fd;
    uint64 addr;
    argint(0, &fd);
    argaddr(3, &addr);
    #ifdef SOCKET_DEBUG
    printf("sendto:fd:%d\n",fd);
    #endif
    if(fd >= SOCKET){
        copyin2((char*)&sockets[fd - SOCKET].sock_opt,addr , 4);
        #ifdef SOCKET_DEBUG
        printf("sokcet_send:%s\n",sockets[fd - SOCKET - 1].temp);
        #endif
        return 0;
    }
    else return -1;
}
uint64 sys_getsockopt(void){
    int fd;
    uint64 addr;
    argint(0, &fd);
    argaddr(3, &addr);
    #ifdef SOCKET_DEBUG
    printf("sendto:fd:%d\n",fd);
    #endif
    if(fd >= SOCKET){
        copyout2(addr ,(char*)&sockets[fd - SOCKET].sock_opt, 4);
        #ifdef SOCKET_DEBUG
        printf("sokcet_send:%s\n",sockets[fd - SOCKET - 1].temp);
        #endif
        return 0;
    }
    else return -1;  
}